/*
  Ein kleines Beispielprogramm zum Erzeugen DREIER
  Threads: Main-Thread, thread1() und thread2()
  Compilieren mit
  gcc -o threads threads.c -lpthread
  und Warnungen ignorieren :-)

  In diesem Programm laufen die Funktionen main(), thread1() und
  thread2() gleichzeitig ab. Miltitasking eben...
 */

#include <stdio.h>
#include <pthread.h>

/* Um zu beweisen, das alle threads auf die selben Variablen
   zugreifen, wird diese Variable von allen threads angezeigt und um
   einz erhoet. */
int lauf = 0;

void thread1(void* data);
void thread2(void* data);

pthread_t        thrd_1;
pthread_t        thrd_2;
pthread_attr_t   thrd_1_attr;
pthread_attr_t   thrd_2_attr;

int main(int argc, char** argv){

  /* Initialisierung des ersten Threadattributes */
  pthread_attr_init(&thrd_1_attr);
  /* Starten des ersten Threads. Achtung: Der Thread laeuft SOFORT
     los! */
  pthread_create(&thrd_1, &thrd_1_attr, thread1, "Hallo");

  /* Initialisierung des zweiten Threads analog zum ersten */
  pthread_attr_init(&thrd_2_attr);
  pthread_create(&thrd_2, &thrd_2_attr, thread2, "Welt");

  while(1){
    printf("Main-Thread (%d)\n", lauf++);
    sleep(1);
  }

  return 0;
}

void thread1(void* data){
  char* d=(char*)data;
  while(1){
    printf("Thread 1: %s (%d)\n",d, lauf++);
    sleep(2);
  }
}

void thread2(void* data){
  char* d=(char*)data;
  while(1){
    printf("Thread 2: %s (%d)\n", d, lauf++);
    sleep(3);
  }
}
